#define _CRT_SECURE_NO_WARNINGS

#include <cstdio>
#include <cmath>
#include <cstring>
#include <algorithm>
#include <set>
#include <map>
#include <vector>
#include <string>
#include <iostream>
#include <fstream>
#include <sstream>
#include <ctime>
#include <Windows.h>

using namespace std;

typedef long long i64;
typedef unsigned int u32;
typedef unsigned short u16;
typedef unsigned char u8;
const int inf = 0x7FFFFFFF;

template<class T> int size(const T& a) {
	return (int)a.size();
}
template<class T> T sqr(const T& a) {
	return a * a;
}
#define null NULL
#define PE printf("PE\n")
#define TL printf("TL\n")
#define WA printf("WA\n")
#define OK printf("OK\n")
#define CHE printf("Check Error\n")

bool Test(ifstream &fin, ifstream &fcor, ifstream &fans) {
	int m[3], a, b, n;
	bool ok = 0;
	bool err = !(fin >> m[0] >> m[1] >> m[2] >> a >> b >> n);
	string correct;
	err |= !(fcor >> correct);
	if (correct.compare("YES") == 0) {
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < 3; j++) {
				int t;
				err |= !(fcor >> t);
			}
		}
	} else if (correct.compare("NO") != 0) {
		err = 1;
	}
	if (err) {
		CHE;
	} else {
		string answer;
		if (!(fans >> answer)) {
			PE;
		} else {
			if (answer.compare(correct) != 0) {
				WA;
			} else {
				if (correct.compare("YES") == 0) {
					int w[3];
					w[0] = a * b, w[1] = b, w[2] = 1;
					int sum = 0;
					for (int i = 0; i < 3; i++) {
						sum += m[i] * w[i];
					}
					bool pe = 0, wa = 0;
					for (int i = 0; i < n; i++) {
						int cur = 0;
						for (int j = 0; j < 3; j++) {
							int t;
							if (!(fans >> t)) {
								pe = 1;
							} else {
								if (t > m[j]) {
									wa = 1;
								}
								m[j] -= t;
								cur += t * w[j];
							}
						}
						if (cur * n != sum) {
							wa = 1;
						}
					}
					if (pe) {
						PE;
					} else if (wa) {
						WA;
					} else {
						ok = 1;
					}
				} else {
					ok = 1;
				}
			}
		}
	}
	return ok;
}
int main(int nargs, char** args) {//t.in, t.out, r.txt
	STARTUPINFO cif;
	ZeroMemory(&cif,sizeof(STARTUPINFO));
	PROCESS_INFORMATION pi;
	if (nargs != 4) {
		printf("invalid number of arguments\n");
	} else if (CreateProcess(L"sol.exe", null, null, null, false, NORMAL_PRIORITY_CLASS, null, null, &cif, &pi)) {
		if (WaitForSingleObject(pi.hProcess, 1000) == WAIT_TIMEOUT) {
			TerminateProcess(pi.hProcess, 0);
			TL;
		} else {
			ifstream fans(args[3]);
			ifstream fin(args[1]);
			ifstream fcor(args[2]);
			if (!fans) {
				PE;
			} else {
				if (!fcor || !fin) {
					CHE;
				} else {
					bool ok = 1;
					for (int i = 0; ok && i < 2; i++) {
						ok &= Test(fin, fcor, fans);
					}
					if (ok) {
						OK;
					}
				}
			}
		}
	} else {
		CHE;
	}
	return 0;
}